<template xmlns="">
  <canvas resize ref="tilingCanvas" class="tiling-canvas"
          @mousedown="onMouseDown">
  </canvas>
  <button @click="resetCanvas">Reset</button>
</template>

<script setup>
//TODO: an jede Veränderung die selbst durch mein programm vorgenommen wird, muss nochmal das valibot ding gecalled werden
//TODO: Jede family um extra änderungen ergänzen, damit manche winkel bei bestimmten veränderungen nicht wegfallen
//TODO: groups, sodass man auf gleich orientierte paths immer dieselben vektoren anwenden kann?
import {ref, computed} from 'vue'
import {Point, Path, PaperScope, Tool, Group} from 'paper'
import {object, number, array, every, forward, custom, parse} from 'valibot';
import {radianToDegree, degreeToRadian} from "~/composables/MathOperations.js";
import * as assert from "assert";

let familyType = useFamilyTypeStore() //welche familie gerade ausgewählt ist und wie das fünfeck verändert wurde
let currentFamily = computed(() => getFamilyByCombinedName(familyType.name)); //das jetzige familienobject mit allen daten und der validierungsfunktion
//TODO: bevor gewechselt wird muss das noch in das Array reingeschrieben werden, ich glaube das reicht nicht

const FamilyTileSchema = object({
      angles: array(number(), [every(angle => angle <= 180, "Not convex")]),
      strokes: array(number([])),
    },
);


let tool = null //paper.Event() //paper.KeyEvent()
const scope = ref(new PaperScope())
const tilingCanvas = ref(null) //the canvas representing all polygons
let movePath = false;
let allPaths = []

let points = computed(() => currentFamily.value.angles.length);
let group = null;
let hitOptions = {
  segments: true,
  stroke: false,
  fill: false,
  tolerance: 5,
};

let baseLength = 100;

//properties of the polygon, when hitting a segment(point) (one angle and two sidelengths can be changed)
let pathHit = null,  //the path object representing the polygon, which is being hit
    segmentHit = null; /*the segment which is being hit*/

watch(() => familyType.name, () => {
  resetCanvas()
});

onMounted(() => {
  tool = new Tool()
  scope.value.setup(tilingCanvas.value)
  //paper.setup(tilingCanvas.value)
  createPaths();
  //scope.value.view.draw()
  
  //Rice 13 will nicht
  
  let p = new Path({
    closed: true,
    strokeColor: 'red',
    strokeWidth: 10
  })

  let poi = scope.value.view.center;
  let lange = 100;
  let angle = 0;
  //p.add(poi)
  poi = poi.add(new Point({length: lange, angle:angle}))
  p.add(poi)
  angle -= 180+120
  poi = poi.add(new Point({length: 209.908, angle: angle}))
  p.add(poi)
  angle -= 180+90
  poi = poi.add(new Point({length: 36.608, angle: angle}))
  p.add(poi)
  angle -= 180+120
  poi = poi.add(new Point({length: lange*2, angle: angle}))
  p.add(poi)
  angle -= 180+90
  poi = poi.add(new Point({length: lange, angle: angle}))
  p.add(poi)
  
})

/*könnte man immer die Mitte der Seite nehmen;
Problem: Muster, die sich nicht "gleichmäßig" ausbreiten*/
const createPaths = () => {
  if(currentFamily.value.strokes.findIndex(findUndefined) !== -1) {
    currentFamily.value.init(baseLength);
  }
  if(!checkStrokes()) {
    return;
  }
  let path;
  const primUnit = currentFamily.value.primitiveUnit;
  //In den for loop muss jetzt eine Bedingung wie "bis der canvas voll ist"
  //TODO: assert(primUnit.count % primUnit.colors.length === 0)
  //how many primitive Units we need
  for (let i = 0; i < 1; i++) {
    //for each element in primitive Unit
    let angle = currentFamily.value.angles[0] + currentFamily.value.angles[1];
    let rotate = [0, angle, -90];
    for (let j = 0; j < primUnit.count; j++) {
      //let color = primUnit.colors[j % primUnit.count] ; //TODO: richtig?
      let clockwise = primUnit.clockwise[j];
      path = createTile(undefined, false);//color, clockwise);
      path.rotation = 0;
      path.rotate(rotate[j], path.segments[1].point); //default is center bei path
      if(j > 0) {
        let lastPath = allPaths[allPaths.length - 1]
        connect(path, lastPath, lastPath.segments[0])
      }
      console.log(path.clockwise)
      allPaths.push(path);
    }
  }
}

const createTile = (color, clockwise) => {
  //Hier wird auf Basis der Familie jetzt das Fünfeck erstellt
  let path = new Path({
    closed: true,
    fillColor: 'lightblue',//color,
    strokeWidth: 5, //bleibt eher so
    strokeColor: 'black',
  });
  let delta = scope.value.view.center; //new Point(0, 0);
  let angle = clockwise ? 0 : 180;
  for (let i = 0; i < points.value; i++) {
    delta = delta.add(new Point({
      length: currentFamily.value.strokes[i],
      //angle: 360-currentFamily.angles[i], //einfacher ansatz (geht vom letzten Punkt aus, nicht von der canvas mitte)
      //angle: (i*72), //old
      //angle: (-180+currentFamily.value.angles[i])*i,//horizontale Kante ist unten FUNKTIONIERT NICHT, WEIL: jetzt das xEck gegen den Uhrzeigersinn rumläuft und die getAngleSegments Methode die Außenwinkel zurückgibt
      angle: angle, //"--" oben (winkel > 0)
    }));
    angle += 180 - currentFamily.value.angles[i];
    //angle += (clockwise ? 180 : -180) - currentFamily.value.angles[i];

    //leider geht die Definition (A..E, a..e) für die Fünfecke mit Wikipedia
    //und dem Erstellen in paperJs nicht ganz auf
    //(wenn man winkel hochdreht, geht das rechts rum, aber auf wikipedia gegen uhrzeigersinn definiert)
    path.add(delta); //mein Gott, bitte hier nicht +, sondern .add() verwenden; vue kennt den überschriebenen Operator nicht
  }

  //TODO: Das hier noch entfernen
  //wenn ich später primitive Units erstelle, kann man immernoch nachdem man createTile aufgerufen hat das Ding drehen und schieben
  //setNewCenter(path, scope.value.view.center);
  return path;
}

/**
 * finds out for a given line defined by point1 and point2, the point on this line that is closest to point3
 * @param point1 point1 defining the line
 * @param point2 point2 defining the line
 * @param point3
 * @returns {paper.Point}
 */
const closestPointOnLine = (point1, point2, point3) => {
  //https://stackoverflow.com/a/47198877
  let pointD = point2.subtract(point1);
  let determinant = pointD.multiply(pointD).x + pointD.multiply(pointD).y;
  let a = (pointD.y * (point3.y - point1.y) + pointD.x * (point3.x - point1.x)) / determinant;
  return new Point(point1.x + a * pointD.x, point1.y + a * pointD.y);
}

/**
 * returns a directed vector with the same slope as vector one
 * @param point1 first point for vector
 * @param point2 second point for vector
 * @returns {paper.Point} the new desired point
 */
const directedVector = (point1, point2) => {
  //let ang = point1.getDirectedAngle(point2);
  //let mult = Math.abs(ang) > 90 ? -1:+1;
  return new Point({length: point2.length, angle: point1.angle});//.multiply(mult);
}



/**
 * gibt zurück, ob zwei vektoren mit maximal 45 grad abweichung gleich orientiert sind
 * @param vec1
 * @param vec2
 * @returns {number}
 */
const sameDir = (vec1, vec2) => {
  let ang = vec1.getDirectedAngle(vec2);
  return Math.abs(ang) > 90 ? -1 : +1;
}

const onMouseDown = () => {
  scope.value.activate() //brauche ich das?
  tool.onMouseDown = (event) => {
    resetProperties();

    let hitResult = scope.value.project.hitTest(event.point, hitOptions);
    if(!hitResult) {
      return;
    }

    pathHit = hitResult.item;
    let [a, s] = calcPolyProperties(pathHit)
    console.log("Seitenlängen:", s)
    console.log("Winkel:", a)
    // //TODO: wenn das hier nicht funzt, dann extra canvas im header erstellen
    //  (dann kann ich auch easy, bei jedem change einfach redrawn)
    //allPaths.findIndex(p => calcCenter(p).subtract(calcCenter(path)).abs().length === 0); //--1 wenn nicht gefunden

    if(hitResult.type === 'segment') {
      segmentHit = hitResult.segment;
      console.log(segmentHit.index, ":", getAngleFromSegment(segmentHit)[0]);
    }

    movePath = hitResult.type === 'fill';
    if(movePath) {
      scope.value.project.activeLayer.addChild(hitResult.item);
    }
  }

  tool.onMouseDrag = (event) => {
    if(!pathHit) {
      return;
    }

    let idx = 0;
    let move = event.delta;
    let tempPath = pathHit.clone({insert: false})

    if(segmentHit) {
      idx = segmentHit.index;
      let tempSegment = tempPath.segments[idx];
      tempSegment.point = tempSegment.point.add(move);

      if(!validatePolygon(tempPath)) {
        return;
      }

      if(currentFamily.value.id === 1) {
      //TODO: schaffst du hier noch Stroke änderungen?
        let A = idx, B, C, D;
        pathHit.segments[idx].point = pathHit.segments[idx].point.add(move);
        if(idx === 3) {
          return;
        }
        switch (idx) {
          case 0:
            B = 4;
            C = idx = 1;
            D = 2;
            break;
          case 1:
            B = 2;
            C = idx = 0;
            D = 4;
            break;
          case 2:
            B = 1;
            C = idx = 4;
            D = 0;
            break;
          case 4:
            B = 0;
            C = idx = 2;
            D = 1;
            break;
        }

        A = pathHit.segments[A].point;
        B = pathHit.segments[B].point;
        C = pathHit.segments[C].point;
        D = pathHit.segments[D].point;

        let newSlope = Math.atan((A.y - B.y) / (A.x - B.x));
        let lengthOtherStroke = D.subtract(C).length
        let xChange = Math.cos(newSlope) * lengthOtherStroke;
        let yChange = Math.sin(newSlope) * lengthOtherStroke;
        //wenn man an den linken beiden Punkten anfasst muss das Steigungsdreieck anders herum angelegt werden
        let right = idx === 0 || idx === 1 ? 1 : -1;
        pathHit.segments[idx].point = D.add(new Point(xChange, yChange).multiply(right));
        let a = getAngleFromSegment(pathHit.segments[0])[0];
        let b = getAngleFromSegment(pathHit.segments[1])[0];
        let d = getAngleFromSegment(pathHit.segments[2])[0];
        let c = getAngleFromSegment(pathHit.segments[3])[0];
        let e = getAngleFromSegment(pathHit.segments[4])[0];

        console.log(a+b, c+d+e)


      }
      else if(currentFamily.value.id === 2) {
        let segments = pathHit.segments;
        let BC = segments[1].point.subtract(segments[2].point),
            ED = segments[4].point.subtract(segments[3].point);
        let mult = 0;
        // noinspection JSMissingSwitchDefault
        switch (idx) {
          case 0:
            //A wird nur entlang b bewegt
            let stroke = segmentHit.point.subtract(segmentHit.next.point);
            mult = sameDir(stroke, move);
            let mve = directedVector(stroke, move).multiply(mult);
            pathHit.segments[idx].point = segments[idx].point.add(mve);
            break;
          case 1:
          case 4:
            mult = sameDir((idx === 1 ? BC : ED), move);
            //B, A und E werden nach unten/oben gezogen
            let moveB = directedVector(BC, move).multiply(mult),
                moveE = directedVector(ED, move).multiply(mult);
            pathHit.segments[0].point = segments[0].point.add(moveB);
            pathHit.segments[1].point = segments[1].point.add(moveB);
            pathHit.segments[4].point = segments[4].point.add(moveE);
            break;
          case 2:
          case 3:
            mult = sameDir((idx === 2 ? BC : ED).multiply(-1), move);
            //C (entlang c) und D (entlang e) werden nach oben/unten gezogen
            let moveC = directedVector(BC.multiply(-1), move).multiply(mult),
                moveD = directedVector(ED.multiply(-1), move).multiply(mult);
            pathHit.segments[2].point = segments[2].point.add(moveC);
            pathHit.segments[3].point = segments[3].point.add(moveD);
            break;
        }
        return;
      }
      else if(currentFamily.value.id === 3 && (idx === 4 || idx === 0 || idx === 1)) {
        //Wie verschiebt man den Punkt A?
        //TODO: Noch nicht ganz so geil
        let segs = pathHit.segments;
        let ED = segs[4].point.subtract(segs[3].point),
            BC = segs[1].point.subtract(segs[2].point),
            Ad = segs[0].point.subtract(closestPointOnLine(segs[2].point, segs[3].point, segs[0].point))

        let x = idx === 0 ? Ad : (idx === 1 ? BC : ED);
        let mult = sameDir(x, move);

        let moveA = directedVector(Ad, move).multiply(mult),
            moveB = directedVector(BC, move).multiply(mult),
            moveE = directedVector(ED, move).multiply(mult);

        pathHit.segments[0].point = segs[0].point.add(moveA);
        pathHit.segments[1].point = segs[1].point.add(moveB);
        pathHit.segments[4].point = segs[4].point.add(moveE);
      }
      else if(currentFamily.value.id === 4 && (idx === 0 || idx === 4)) {
        const rotSeg = pathHit.segments[2];
        let triangle = new Path({
          segments: [segmentHit.clone(), pathHit.segments[idx === 0 ? 1 : 3].clone(), rotSeg.clone()],
          insert: true,
          closed: true
        });
        let stroke = rotSeg.point.subtract(segmentHit.index.point); //gleichzeitig auch der Radius von dem Kreis
        let clockwise = sameDir(stroke, move);
        let angle = (360 * move.length) / (2 * Math.PI * stroke.length); //https://de.bettermarks.com/mathe/kreisausschnitt-und-kreisbogen/
        triangle.rotate(angle * clockwise, triangle.segments[2].point);
        pathHit.segments[idx].point = triangle.segments[0].point.clone();
        pathHit.segments[idx === 0 ? 1 : 3].point = triangle.segments[1].point.clone();
        pathHit.segments[2].point = triangle.segments[2].point.clone();
        triangle.remove();
      }
      else if(currentFamily.value.id === 5 && (idx === 1 || idx === 2)) {
        const rotSeg = pathHit.segments[4];
        let triangle = new Path({
          segments: [segmentHit.clone(), pathHit.segments[idx === 1 ? 0 : 3].clone(), rotSeg.clone()],
          insert: true,
          closed: true
        });
        let stroke = rotSeg.point.subtract(segmentHit.index.point); //gleichzeitig auch der Radius von dem Kreis
        let clockwise = sameDir(stroke, move);
        let angle = (360 * move.length) / (2 * Math.PI * stroke.length); //https://de.bettermarks.com/mathe/kreisausschnitt-und-kreisbogen/
        triangle.rotate(angle * clockwise, triangle.segments[2].point);
        pathHit.segments[idx].point = triangle.segments[0].point.clone();
        pathHit.segments[idx === 1 ? 0 : 3].point = triangle.segments[1].point.clone();
        pathHit.segments[4].point = triangle.segments[2].point.clone();
        triangle.remove();
      }
      else if(currentFamily.value.id === 7 && (idx === 1 || idx === 3)) {
        //TODO: need to work on displaying correct angle values (adjust strokelenghts)
        switch (idx) {
          case 1:
            break;
          case 3:
            break;
        }
      }
      else if(currentFamily.value.id === 11) {
        let move = 0;
        switch (idx) {
          case 0:
          case 1:
            break;
          case 2:
          case 4:
            break;
        }
        pathHit.segments[3].point = pathHit.segments[3].point.add(move)
      }  /*else {
        segmentHit.point = segmentHit.point.add(move);
      }*/

    } /* nur für develop*/ else if(pathHit) {
      //hier werden dann in "production" immer neue tiles erstellt und gelöscht, wenn der canvas verschoben wird
      //dadurch soll die Illusion entstehen, dass es unendlich weit in alle Richtungen geht
      pathHit.position = pathHit.position.add(move);
    }

    //TODO: Veränderung geht nicht auf alle gleich, da manche Tiles ja rotiert sind
    //TODO: Hier muss der move vektor gedreht werden, je nachdem wie ein tile gedreht ist
    //Veränderung auf alle übertragen:
    //let currentPathIndex = allPaths.findIndex(p => calcCenter(p).subtract(calcCenter(path)).abs().length === 0)
    //TODO: Für jede Rotation jeden(alle) Bewegungsvektoren speichern, mit dazugehörigen Segment und dann alle paths filtern und so anwenden
    let currentPathIndex = allPaths.findIndex(p => p.id === pathHit.id) //Das hier funzt, aber ist nicht so cool wie das hier drüber
    for (let i = 0; i < allPaths.length; i++) {
      if(i !== currentPathIndex) {
        let changedSegment = allPaths[i].segments[segmentHit.index];
        changedSegment.point = changedSegment.point.add(move);
      }
    }
  };

  tool.onMouseUp = (event) => {
    //Daten an Header senden oder so
    if(pathHit != null) {
      [currentFamily.value.angles, currentFamily.value.strokes] = calcPolyProperties(pathHit)
    }
  };

  tool.onMouseMove = (event) => {
    scope.value.project.activeLayer.selected = false;
    if(event.item) {
      event.item.selected = true;
    }
  }
}

/**
 * moves the current clicked-on segment by a specified amount
 * @param move
 */
const freelyMoveSegment = (move) => {
  segmentHit.point = segmentHit.point.add(move);
}

/**
 * validates, whether the given path object satisfies the current family rules
 * @param polygon the path object to validate
 * @returns {boolean} valid or not
 */
const validatePolygon = (polygon) => {
  let [a, s] = calcPolyProperties(polygon)
  let valid = true;
  let tile;
  try {
    tile = parse(FamilyTileSchema, {
      angles: a,
      strokes: s,
    })
    currentFamily.value.angles = tile.angles;
    currentFamily.value.strokes = tile.strokes;
  } catch (error) {
    valid = false;
    console.log(error);
  }

  return valid;
}

/**
 * deletes the canvas and redraws all polygons in their original states
 */
const resetCanvas = () => {
  scope.value.project.activeLayer.removeChildren();
  allPaths = [];
  createPaths();
};

/**
 * resets the currently selected objects
 */
const resetProperties = () => {
  pathHit = segmentHit = null;
}

/**
 * calculates the angle of a given segment defined by the two strokes touching the segment
 * @param seg The given segment on a path
 * @returns {[number,number,number]} angle of the segment and the length of both strokes
 */
const getAngleFromSegment = (seg) => {
  //https://stackoverflow.com/a/37211434
  let vectorBefore = seg.point.subtract(seg.previous.point),
      vectorAfter = seg.point.subtract(seg.next.point),
      //TODO: vorsichtig pathHit
      angle = pathHit.clockwise ?
          vectorAfter.getDirectedAngle(vectorBefore) : vectorBefore.getDirectedAngle(vectorAfter);

      angle = mod(angle, 360);

  return [angle, vectorBefore.length, vectorAfter.length];
}

/**
 * Whenever the canvas gets (re)drawn, it is checked whether all sideLenghts for the tile are already defined,
 * or if 1 or 2 (no more) need to be calculated
 */
const checkStrokes = () => {
  let valid = true;
  //Each polygon has a different min req.
  //Here init all side lenghts based on these req.

  //Calculate missing strokelenghts:

  let firstOcc = currentFamily.value.strokes.findIndex(findUndefined),
      lastOcc = currentFamily.value.strokes.findLastIndex(findUndefined);
  let diff = lastOcc - firstOcc; //abs not neccessary (findLastIndex >= findIndex), but do it anyway, you never know
  let legal = diff <= 1 || diff === points.value - 1;
  if(firstOcc===lastOcc && firstOcc !==-1){
    console.warn("Polygon may not be drawn correctly, every stroke except one is given")
    console.log(currentFamily.value.strokes)
  }
  if(firstOcc !== -1) {
    if(!legal) {
      //Wenn die beiden fehlenden Seiten nicht hintereinanderliegen
      //und nicht die letzte und erste zeitgleich sind [undef, b, c, d, undef]
      console.error("Cannot create polygon. Not enough given strokelenghts in succession")
      valid = false;
    }
    else {
      //one or two sidelengths are missing, let's calculate them
      //when the last unknown segmentlength is the last, start at the front
      let start = ((diff > 1 ? firstOcc : lastOcc) + 1) % points.value;
      console.log(start)
      calcMissingSidelenghts(start);
    }
  }
  //All side lengths and angles are given and correct (hopefully) so we create them:
  return valid;
}

/**
 * Returns every angle and strokelength for a given polygon defined as a Path object
 * @param polygon the given path object
 * @returns {[number[],number[]]} the angles and stroke lenghts
 */
const calcPolyProperties = (polygon) => {
  let angs = [0, 0, 0, 0, 0]
  let strokeLengths = [0, 0, 0, 0, 0]
  for (let i = 0; i < points.value; i++) {
    [angs[i], strokeLengths[i],] = getAngleFromSegment(polygon.segments[i]);
  }
  return [angs, strokeLengths]
}

/**
 * Given atleast 3 consecutive sidelenghts and all angles (currentFamily) for a 5-sided-polygon, calculate the remaining sidelenghts
 * @param start defines where to start the calculation for the missing side length. The next 3 sides from this point on need to be defined
 */
const calcMissingSidelenghts = (start) => {
  //Algo: https://math.stackexchange.com/a/256439
  let angls = currentFamily.value.angles;
  let strks = currentFamily.value.strokes;
  let strksC = points.value;
  let left = strks[start];
  let alpha = angls[start];
  start = mod(start + 1, strksC);
  let right = currentFamily.value.strokes[start], bottom;
  let beta, gamma;

  let lastAng = 0;

  for (let i = 0; i < 2; i++) {
    //cosine rule
    bottom = Math.sqrt(Math.pow(left, 2) + Math.pow(right, 2) - 2 * left * right * Math.cos(degreeToRadian(alpha)))
    //sine rule
    let h = Math.sin(degreeToRadian(alpha)) / bottom;

    beta = radianToDegree(Math.asin(h * right));
    gamma = radianToDegree(Math.asin(h * left));

    alpha = angls[start] - gamma;
    start = mod(start + 1, strksC);
    right = strks[start];
    lastAng += beta;
    // noinspection JSSuspiciousNameCombination
    left = bottom;
  }

  let h = Math.sin(degreeToRadian(angls[start])) / left;

  lastAng = angls[mod(start + 1, strksC)] - lastAng;

  for (let ang of [lastAng, alpha]) {
    let a = Math.sin(degreeToRadian(ang)) / h;
    if(typeof (currentFamily.value.strokes[start]) === "undefined") {
      console.log(a);
      currentFamily.value.strokes[start] = a;
    }
    start = mod(start + 1, strksC);
  }
}

/**
 * moves the polygon's center to a new desired location
 * @param polygon the polygon to be moved
 * @param newCenter the polygon's new center location
 */
const setNewCenter = (polygon, newCenter) => {
  let centerOfPolygon = calcCenter(polygon)
  //entweder neuen mittelpunkt setzen oder jeden Punkt um einen Wert/Punkt verschieben

  //calc how much to move every point by
  let diff = centerOfPolygon.subtract(newCenter);

  //movePolygon(polygon, diff.multiply(-1))
  //move every point by that difference
  for (let i = 0; i < points.value; i++) {
    polygon.segments[i].point = polygon.segments[i].point.subtract(diff)
  }
}

/**
 * returns the middlepoint for a given polygon
 * @param polygon polygon to calculate the center of
 * @returns {paper.Point} centerpoint
 */
const calcCenter = (polygon) => {
  let centerOfPolygon = new Point(0, 0)
  //calc current centerpoint
  for (let i = 0; i < points.value; i++) {
    centerOfPolygon = polygon.segments[i].point.add(centerOfPolygon)
  }

  return centerOfPolygon.divide(points.value)
}

/**
 * moves a polygon such that each point defining the polygon gets moved by a defined amount
 * @param polygon the polygon to be moved
 * @param offset the point defining the movement of the polygon
 */
const movePolygon = (polygon, offset) => {
  for (let i = 0; i < points.value; i++) {
    polygon.segments[i].point = polygon.segments[i].point.add(offset)
  }
}

/**
 * moves another polygon, such that it connects to a given other one
 * @param polygon1
 * @param polygon2
 * @param segment
 */
const connect = (polygon1, polygon2, segment) => {
  let idx = segment.index;
  let connectionPoint = segment.point;
  let polygon = polygon1.segments.filter(x => x.point === connectionPoint).length === 1 ? polygon2 : polygon1;
  let diff = segment.point.subtract(segment.next.point)
  movePolygon(polygon, diff);
}

const findUndefined = (obj) => {
  return typeof (obj) === "undefined";
}

/**
 * find out if two numbers are the same with a certain tolerance
 * @param num1 first number
 * @param num2 second number
 * @param prec desired precision
 * @returns {boolean} about equal
 */
function equals(num1, num2, prec = 0.000001) {
  return Math.abs(num1 - num2) < prec;
}

</script>

<style scoped>
@import '../../main.css';
</style>
